package be.jeffcheasey88.peeratcode.parser.java;

import static org.junit.jupiter.api.Assertions.assertEquals;

import java.util.ArrayList;
import java.util.List;

import org.junit.jupiter.api.Test;

import be.jeffcheasey88.peeratcode.parser.java.CleanerPool.Cutter;

public class CleanerTest {

	@Test
	void cutter(){
		Cutter generic = new Cutter(){
			@Override
			public String execute(String value, List<String> constants, String pattern){
				String result = "";
				for(int i = 0; i < value.length(); i++){
					char c = value.charAt(i);
					if(c == '<'){
						i+=cutOpenable(value.substring(i+1), constants, pattern, '<', '>');
						result+=pattern+(constants.size()-1);
					}else{
						result+=c;
					}
				}
				return result;
			}
		};
		
		List<String> list = new ArrayList<>();
		String result = generic.execute("test<Test<Lol>>", list, "$TEST");
		assertEquals(list.size(), 2);
		assertEquals(list.get(0), "Lol");
		assertEquals(list.get(1), "Test$TEST0");
		assertEquals("test$TEST1", result);
	}
}
